# $Id: djbdns.spec 498 2006-09-12 22:39:53Z mike $

%define svscan_home %{_localstatedir}/svscan
%define services_home %{_localstatedir}/services

Summary: Robust DNS cache and server
Name: djbdns
Version: 1.05
Release: %RErelease 10
Epoch: 0
License: 17 USC 117
Group: Applications/System
URL: http://cr.yp.to/djbdns.html
Source0: http://cr.yp.to/djbdns/%{name}-%{version}.tar.gz
Source1: http://cr.yp.to/djbdns/doc.tar.gz
Source2: http://smarden.org/pape/djb/manpages/%{name}-%{version}-man.tar.gz
Source3: http://www.hungry.com/~fn/dnscache-log.pl.txt
Source4: http://www.tinydns.org/tinydns-log.pl.txt
Source5: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/dnscache-showctl
Source6: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/tinydns-showctl
Source7: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/dnsqrx
Source8: http://www.soffian.org/downloads/tinydns-stats.pl
Source9: http://www.gerg.ca/hacks/parse_djbdns_log
Source10: dnsnamex.1
Source11: dnsqrx.1
Patch0: http://www.tinydns.org/djbdns-errno.patch
Patch1: http://dustman.net/andy/djbware/djbdns/1.05/djbdns.patch
Patch2: http://tinydns.org/djbdns-1.05-ignoreip2.patch
Patch3: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/tinydns-data-semantic-error.patch
Patch4: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/dnscache-cname-handling.patch
Patch5: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/tinydns-alias-chain-truncation.patch
Patch6: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/dnsnamex.patch
Patch7: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/dnscache-strict-forwardonly.patch
Patch8: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/compiler-temporary-filename.patch
Patch9: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/dnscacheip-space-separator.patch
Patch10: http://www.ohse.de/uwe/patches/dnscache-0.61.okclient.patch
Patch11: http://danp.net/djbdns/server-1.05-nxdomain-logging.patch
Patch12: djbdns-1.05.dnsroots.global.patch
Patch13: http://www.fefe.de/dns/djbdns-1.05-ixfr.diff
Patch14: http://romana.now.ie/software/djbdns-cachestats.patch
Patch15: http://www.gerg.ca/hacks/parse_djbdns_log.hits-misses.patch
Patch16: djbdns-1.05-opt_freeware.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
NoSource: 0
NoSource: 1

%description
Dan J. Bernstein's DNS tools.
Useful utilities for performing various DNS queries.

%package devel
Summary: DNS development libraries
Group: Development/Libraries
URL: http://cr.yp.to/djbdns/dns.html

%description devel
Dan J. Bernstein's DNS tools.
These are DNS client library routines. They are meant to be used in
browsers and other programs that resolve domain names.

%package axfrdns
Summary: Zone transfer server
Group: System Environment/Daemons
URL: http://cr.yp.to/djbdns/axfrdns.html
Requires: daemontools >= 0.70, ucspi-tcp >= 0.88, djbdns-tinydns

%description axfrdns
Dan J. Bernstein's DNS tools.
axfrdns is a DNS zone-transfer server. It reads a zone-transfer request
in DNS-over-TCP format from its standard input, and responds with locally
configured information.

%package dnscache
Summary: Cache-only DNS server
Group: System Environment/Daemons
URL: http://cr.yp.to/djbdns/dnscache.html
Requires: daemontools >= 0.70

%description dnscache
Dan J. Bernstein's DNS tools.
dnscache is a DNS cache. It accepts recursive DNS queries from local
clients such as web browsers and mail transfer agents. It collects
responses from remote DNS servers. It caches the responses to save
time later.

%package pickdns
Summary: Load-balancing DNS server
Group: System Environment/Daemons
URL: http://cr.yp.to/djbdns/pickdns.html
Requires: daemontools >= 0.70

%description pickdns
Dan J. Bernstein's DNS tools.
pickdns is a load-balancing DNS server. It accepts iterative DNS queries
from hosts around the Internet, and responds with a dynamic selection of
locally configured IP addresses with 5-second TTLs.

%package rbldns
Summary: IP-address listing DNS server
Group: System Environment/Daemons
URL: http://cr.yp.to/djbdns/rbldns.html
Requires: daemontools >= 0.70

%description rbldns
Dan J. Bernstein's DNS tools.
rbldns is an IP-address-listing DNS server. It accepts iterative DNS
queries from hosts around the Internet asking about various IP addresses.
It provides responses showing whether the addresses are on a locally
configured list, such as RBL or DUL.

%package tinydns
Summary: Lightweight, full-featured DNS server
Group: System Environment/Daemons
URL: http://cr.yp.to/djbdns/tinydns.html
Requires: daemontools >= 0.70

%description tinydns
Dan J. Bernstein's DNS tools.
tinydns is a DNS server. It accepts iterative DNS queries from hosts
around the Internet, and responds with locally configured information.

%package walldns
Summary: Reverse DNS wall
Group: System Environment/Daemons
URL: http://cr.yp.to/djbdns/walldns.html
Requires: daemontools >= 0.70

%description walldns
Dan J. Bernstein's DNS tools.
walldns is a reverse DNS wall. It accepts iterative DNS queries for
in-addr.arpa domains from hosts around the Internet, and supplies generic
responses that avoid revealing local host information.

%prep 
%setup -q
%setup -q -D -T -a 1
%setup -q -D -T -a 2
%{__sed} 's|/usr/local/bin/python|%{__python}|' %{SOURCE9} > parse_djbdns_log
%patch0 -b .errno
%patch1 -b .hier
%patch2 -b .ignoreip2
%patch3 -b .semerr
%patch4 -p1 -b .cname
%patch5 -p1 -b .tiny-act
%patch6 -b .dnsnamex
%patch7 -p1 -b .cache-strict
%patch8 -p1 -b .tmpname
%patch9 -p1 -b .cache-sep
%patch10 -b .okclient
%patch11 -b .nxdomain
%patch12 -p1 -b .dnsroots
%patch13 -p1 -b .ixfr
%patch14 -p1 -b .cachestats
%patch15 -b .hitmiss
%ifos aix4.3 aix5.1 aix5.2 aix5.3
%patch16 -p1 -b .freeware
%{__sed} -e's|"/tmp/djbdns"|auto_install|' hier.c > hier.c.new && %{__mv} hier.c.new hier.c
%else
%{__sed} -e's|/tmp/djbdns|%{_tmppath}/%{name}-%{version}-%{release}-root|' hier.c > hier.c.new && %{__mv} hier.c.new hier.c
%endif
%{__cp} -p %{PATCH2} .
%{__cp} -p %{PATCH10} .

%build
echo "%{_prefix}" > conf-home
echo "${RPM_BUILD_ROOT}%{_prefix}" > conf-install
%{__make}

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && %{__rm} -rf $RPM_BUILD_ROOT
%{__install} -m 0755 -d ${RPM_BUILD_ROOT}%{_sysconfdir}
%{__install} -m 0755 -d ${RPM_BUILD_ROOT}%{_bindir}
%{__install} -m 0755 -d ${RPM_BUILD_ROOT}%{_datadir}/doc
%{__make} setup
%{__install} -m 0755 dnsnamex ${RPM_BUILD_ROOT}%{_bindir}
%{__install} -m 0755 -d ${RPM_BUILD_ROOT}%{_libdir}/%{name}
%{__install} -m 0755 -d ${RPM_BUILD_ROOT}%{_includedir}/%{name}
%{__cp} *.a ${RPM_BUILD_ROOT}%{_libdir}/%{name}
%{__cp} *.h ${RPM_BUILD_ROOT}%{_includedir}/%{name}
%{__install} -m 0755 %{SOURCE3} ${RPM_BUILD_ROOT}%{_bindir}/dnscache-log.pl
%{__install} -m 0755 %{SOURCE4} ${RPM_BUILD_ROOT}%{_bindir}/tinydns-log.pl
%{__install} -m 0755 %{SOURCE5} ${RPM_BUILD_ROOT}%{_bindir}/dnscache-showctl
%{__install} -m 0755 %{SOURCE6} ${RPM_BUILD_ROOT}%{_bindir}/tinydns-showctl
%{__install} -m 0755 %{SOURCE7} ${RPM_BUILD_ROOT}%{_bindir}/dnsqrx
%{__install} -m 0755 %{SOURCE8} ${RPM_BUILD_ROOT}%{_bindir}/tinydns-stats.pl
%{__install} -m 0755 parse_djbdns_log ${RPM_BUILD_ROOT}%{_bindir}/parse_djbdns_log
cd %{name}-man
%{__mv} README README.man
for X in 1 5 8; do
  for MAN in `ls *.$X`; do
    %{__install} -m 0644 -D $MAN ${RPM_BUILD_ROOT}%{_mandir}/man${X}/${MAN}
  done
done
cd ..
%{__install} -m 0644 %{SOURCE10} ${RPM_BUILD_ROOT}%{_mandir}/man1/
%{__install} -m 0644 %{SOURCE11} ${RPM_BUILD_ROOT}%{_mandir}/man1/

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && %{__rm} -rf $RPM_BUILD_ROOT

%post axfrdns
# Only if a first install...
if [ "$1" = 1 ]; then
  %{_bindir}/axfrdns-conf tinydns dnslog %{services_home}/axfrdns %{services_home}/tinydns 0.0.0.0
fi

%preun axfrdns
# Only if a last uninstall...
if [ "$1" = 0 ]; then
  %{__rm} -f %{svscan_home}/axfrdns
  %{_bindir}/svc -dx %{services_home}/axfrdns %{services_home}/axfrdns/log
  %{__rm} -rf %{services_home}/axfrdns
fi

%post dnscache
# Only if a first install...
if [ "$1" = 1 ]; then
%ifos aix4.3 aix5.1 aix5.2 aix5.3
  if ! lsuser dnscache >/dev/null 2>&1; then
    mkgroup dnscache
    mkuser pgrp=dnscache home=%{services_home}/dnscache admin=false login=false rlogin=false dnscache
  fi
  if ! lsuser dnslog >/dev/null 2>&1; then
    mkgroup dnslog
    mkuser pgrp=dnslog home=%{services_home}/tinydns admin=false login=false rlogin=false dnslog
  fi
%else
  if ! getent passwd dnscache >/dev/null 2>&1; then
    /usr/sbin/useradd -s /sbin/nologin -d %{services_home}/dnscache -r dnscache
  fi
  if ! getent passwd dnslog >/dev/null 2>&1; then
    /usr/sbin/useradd -s /sbin/nologin -d %{services_home}/tinydns -r dnslog
  fi
%endif
  %{_bindir}/dnscache-conf dnscache dnslog %{services_home}/dnscache
fi

%preun dnscache
# Only if a last uninstall...
if [ "$1" = 0 ]; then
  %{__rm} -f %{svscan_home}/dnscache
  %{_bindir}/svc -dx %{services_home}/dnscache %{services_home}/dnscache/log
  %{__rm} -rf %{services_home}/dnscache
%ifos aix4.3 aix5.1 aix5.2 aix5.3
  rmuser dnscache
  rmgroup dnscache
%else
  /usr/sbin/userdel dnscache
%endif
fi

%post pickdns
# Only if a first install...
if [ "$1" = 1 ]; then
%ifos aix4.3 aix5.1 aix5.2 aix5.3
  if ! lsuser pickdns >/dev/null 2>&1; then
    mkgroup pickdns
    mkuser pgrp=pickdns home=%{services_home}/pickdns admin=false login=false rlogin=false pickdns
  fi
  if ! lsuser dnslog >/dev/null 2>&1; then
    mkgroup dnslog
    mkuser pgrp=dnslog home=%{services_home}/tinydns admin=false login=false rlogin=false dnslog
  fi
%else
  if ! getent passwd pickdns >/dev/null 2>&1; then
    /usr/sbin/useradd -s /sbin/nologin -d %{services_home}/pickdns -r pickdns
  fi
  if ! getent passwd dnslog >/dev/null 2>&1; then
    /usr/sbin/useradd -s /sbin/nologin -d %{services_home}/tinydns -r dnslog
  fi
%endif
  %{_bindir}/pickdns-conf pickdns dnslog %{services_home}/pickdns 0.0.0.0
fi

%preun pickdns
# Only if a last uninstall...
if [ "$1" = 0 ]; then
  %{__rm} -f %{svscan_home}/pickdns
  %{_bindir}/svc -dx %{services_home}/pickdns %{services_home}/pickdns/log
  %{__rm} -rf %{services_home}/pickdns
%ifos aix4.3 aix5.1 aix5.2 aix5.3
  rmuser pickdns
  rmgroup pickdns
%else
  /usr/sbin/userdel pickdns
%endif
fi

%post rbldns
# Only if a first install...
if [ "$1" = 1 ]; then
%ifos aix4.3 aix5.1 aix5.2 aix5.3
  if ! lsuser rbldns >/dev/null 2>&1; then
    mkgroup rbldns
    mkuser pgrp=rbldns home=%{services_home}/rbldns admin=false login=false rlogin=false rbldns
  fi
  if ! lsuser dnslog >/dev/null 2>&1; then
    mkgroup dnslog
    mkuser pgrp=dnslog home=%{services_home}/tinydns admin=false login=false rlogin=false dnslog
  fi
%else
  if ! getent passwd rbldns >/dev/null 2>&1; then
    /usr/sbin/useradd -s /sbin/nologin -d %{services_home}/rbldns -r rbldns
  fi
  if ! getent passwd dnslog >/dev/null 2>&1; then
    /usr/sbin/useradd -s /sbin/nologin -d %{services_home}/tinydns -r dnslog
  fi
%endif
  %{_bindir}/rbldns-conf rbldns dnslog %{services_home}/rbldns 0.0.0.0 rbl.localdomain
fi

%preun rbldns
# Only if a last uninstall...
if [ "$1" = 0 ]; then
  %{__rm} -f %{svscan_home}/rbldns
  %{_bindir}/svc -dx %{services_home}/rbldns %{services_home}/rbldns/log
  %{__rm} -rf %{services_home}/rbldns
%ifos aix4.3 aix5.1 aix5.2 aix5.3
  rmuser rbldns
  rmgroup rbldns
%else
  /usr/sbin/userdel rbldns
%endif
fi

%post tinydns
# Only if a first install...
if [ "$1" = 1 ]; then
%ifos aix4.3 aix5.1 aix5.2 aix5.3
  if ! lsuser tinydns >/dev/null 2>&1; then
    mkgroup tinydns
    mkuser pgrp=tinydns home=%{services_home}/tinydns admin=false login=false rlogin=false tinydns
  fi
  if ! lsuser dnslog >/dev/null 2>&1; then
    mkgroup dnslog
    mkuser pgrp=dnslog home=%{services_home}/tinydns admin=false login=false rlogin=false dnslog
  fi
%else
  if ! getent passwd tinydns >/dev/null 2>&1; then
    /usr/sbin/useradd -s /sbin/nologin -d %{services_home}/tinydns -r tinydns
  fi
  if ! getent passwd dnslog >/dev/null 2>&1; then
    /usr/sbin/useradd -s /sbin/nologin -d %{services_home}/tinydns -r dnslog
  fi
%endif
  %{_bindir}/tinydns-conf tinydns dnslog %{services_home}/tinydns 0.0.0.0
fi

%preun tinydns
# Only if a last uninstall...
if [ "$1" = 0 ]; then
  %{__rm} -f %{svscan_home}/tinydns
  %{_bindir}/svc -dx %{services_home}/tinydns %{services_home}/tinydns/log
  %{__rm} -rf %{services_home}/tinydns
%ifos aix4.3 aix5.1 aix5.2 aix5.3
  rmuser tinydns
  rmgroup tinydns
%else
  /usr/sbin/userdel tinydns
%endif
fi

%post walldns
# Only if a first install...
if [ "$1" = 1 ]; then
%ifos aix4.3 aix5.1 aix5.2 aix5.3
  if ! lsuser walldns >/dev/null 2>&1; then
    mkgroup walldns
    mkuser pgrp=walldns home=%{services_home}/walldns admin=false login=false rlogin=false walldns
  fi
  if ! lsuser dnslog >/dev/null 2>&1; then
    mkgroup dnslog
    mkuser pgrp=dnslog home=%{services_home}/tinydns admin=false login=false rlogin=false dnslog
  fi
%else
  if ! getent passwd walldns >/dev/null 2>&1; then
    /usr/sbin/useradd -s /sbin/nologin -d %{services_home}/walldns -r walldns
  fi
  if ! getent passwd dnslog >/dev/null 2>&1; then
    /usr/sbin/useradd -s /sbin/nologin -d %{services_home}/tinydns -r dnslog
  fi
%endif
  %{_bindir}/walldns-conf walldns dnslog %{services_home}/walldns 0.0.0.0
fi

%preun walldns
# Only if a last uninstall...
if [ "$1" = 0 ]; then
  %{__rm} -f %{svscan_home}/walldns
  %{_bindir}/svc -dx %{services_home}/walldns %{services_home}/walldns/log
  %{__rm} -rf %{services_home}/walldns
%ifos aix4.3 aix5.1 aix5.2 aix5.3
  rmuser walldns
  rmgroup walldns
%else
  /usr/sbin/userdel walldns
%endif
fi

%files
%defattr(-,root,root)
%doc CHANGES README TODO TINYDNS %{name}-man/README.man
%doc djbdns-1.05-ignoreip2.patch dnscache-0.61.okclient.patch
%doc doc/host/cr.yp.to/*
%{_bindir}/dnsfilter
%{_bindir}/dnsip
%{_bindir}/dnsipq
%{_bindir}/dnsmx
%{_bindir}/dnsname
%{_bindir}/dnsq
%{_bindir}/dnsqr
%{_bindir}/dnstrace
%{_bindir}/dnstracesort
%{_bindir}/dnstxt
%{_bindir}/random-ip
%{_bindir}/dnsnamex
%{_bindir}/dnsqrx
%{_bindir}/parse_djbdns_log
%doc %{_mandir}/*/dnsfilter.*
%doc %{_mandir}/*/dnsip.*
%doc %{_mandir}/*/dnsipq.*
%doc %{_mandir}/*/dnsmx.*
%doc %{_mandir}/*/dnsname.*
%doc %{_mandir}/*/dnsnamex.*
%doc %{_mandir}/*/dnsq.*
%doc %{_mandir}/*/dnsqr.*
%doc %{_mandir}/*/dnsqrx.*
%doc %{_mandir}/*/dnstrace.*
%doc %{_mandir}/*/dnstracesort.*
%doc %{_mandir}/*/dnstxt.*
%doc %{_mandir}/*/qualification.*

%files devel
%defattr(-,root,root)
%{_libdir}/%{name}
%{_includedir}/%{name}

%files axfrdns
%defattr(-,root,root)
%{_bindir}/axfr-get
%{_bindir}/axfrdns
%{_bindir}/axfrdns-conf
%doc %{_mandir}/*/axfr*

%files dnscache
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/dnsroots.global
%{_bindir}/dnscache
%{_bindir}/dnscache-conf
%{_bindir}/dnscache-log.pl
%{_bindir}/dnscache-showctl
%doc %{_mandir}/*/dnscache*

%files pickdns
%defattr(-,root,root)
%{_bindir}/pickdns
%{_bindir}/pickdns-conf
%{_bindir}/pickdns-data

%files rbldns
%defattr(-,root,root)
%{_bindir}/rbldns
%{_bindir}/rbldns-conf
%{_bindir}/rbldns-data
%doc %{_mandir}/*/rbldns*

%files tinydns
%defattr(-,root,root)
%{_bindir}/tinydns
%{_bindir}/tinydns-conf
%{_bindir}/tinydns-data
%{_bindir}/tinydns-edit
%{_bindir}/tinydns-get
%{_bindir}/tinydns-log.pl
%{_bindir}/tinydns-showctl
%{_bindir}/tinydns-stats.pl
%doc %{_mandir}/*/tinydns*

%files walldns
%defattr(-,root,root)
%{_bindir}/walldns
%{_bindir}/walldns-conf
%doc %{_mandir}/*/walldns*

%changelog
* Sun Jan 08 2006 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 1.05-10
- Added man pages for dnsnamex and dnsqrx.
- Fixed useradd logic.
- Added AIX build support.

* Sun Dec 18 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 1.05-9
- Refactored.
- Rebuilt in new build system.

* Sat Apr 02 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 1.05-8
- Added defattr to docs sub-package.
- Changes user's shells from /bin/false to /sbin/nologin.
- Fixed ${daemontools_home}/svc to be %{daemontools_home}/bin/svc.

* Thu Sep 18 2003 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 1.05-7
- Added djbdns-1.05-ignoreip2 patch

* Wed Jun 25 2003 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 1.05-6
- Red Hat 9 now needs to #include <errno.h> in error.h

* Sun Feb 11 2000 Andy Dustman <andy@dustman.net>
- Some spec file cleanups from Adrian Ho.
- Update to 1.05.
- Include docs package.

* Thu Feb 08 2000 Andy Dustman <andy@dustman.net>
- General cleanups.

